renoise.tool():add_keybinding {
  name = "Global:Tools:MPE",
  invoke = function()main() end 
}

renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:MPE",
  invoke = function() main() end
}

--main
-----------------
local my_dialog = nil
function main()--1 dialog at a time
  if (my_dialog and my_dialog.visible) then -- only allows one dialog instance
      my_dialog:close() return 
  end
-----------------


----------------------------------------------------------------------
local vb = renoise.ViewBuilder()
local starting_pattern = false
local beats_per_bar = 4
local lpb = renoise.song().transport.lpb
local current_pos = renoise.song().transport.playback_pos_beats
local total_rounded_beats = math.floor(current_pos + 1)
local bar = (total_rounded_beats / beats_per_bar)
local beat_in_bar = total_rounded_beats % beats_per_bar
local default_dialog_margin = renoise.ViewBuilder.DEFAULT_DIALOG_MARGIN
local default_control_spacing = renoise.ViewBuilder.DEFAULT_CONTROL_SPACING
local text_row_width = 10
local text_row_space = 60
local blank_space = 1
local btn_trns_width = 75
local btn_trns_height = 50
local btn_common_height = 22
local btn_common_width = 75
local btn_function_width = 62

local btn_red = {0xaf, 0x3a, 0x24}
local btn_redled = {0xaf, 0x00, 0x00}
local btn_otherred = {0xdc, 0x55, 0x37}
local btn_blueled = {0x00, 0x89, 0xce}
local btn_white = {0xf5, 0xf5, 0xf5}
local btn_ivory = {0xdc, 0xdc, 0xdc}
local btn_darkergrey = {0x61, 0x61, 0x61}
local btn_darkgrey = {0x43, 0x43, 0x43}
local btn_grey = {0x7c, 0x7c, 0x7c}
local btn_purple = {0x63, 0x63, 0x8C}
local btn_charcoal = {0x29, 0x29, 0x30}
local btn_green = {0x00, 0xc3, 0x5c}
local btn_orange = {0xef, 0x6a, 0x24}

local btn_f1 = btn_white
local btn_f2 = btn_darkgrey
local btn_f3 = btn_grey
local btn_f4 = btn_darkgrey

local btn_f_on = btn_green
local btn_t_on = btn_redled
local btn_t1 = btn_red
local btn_t2 = btn_ivory

local sampcount = 0
local dispcount = 0
local sampdg = false
local original_timing = renoise.song().transport.lpb
local tempo = nil
local counter = 0
local last_clock = 0
local timetable = table.create()
local timetable_filled = false
local options = renoise.Document.create("ScriptingToolPreferences") {
--tap tempo hits to create a new bmp
      sensitivity = 3,
      round_bpm = true,
      auto_save_bpm = true,
      }
      
-----------------
bar = math.ceil(bar)
-----------------
if beat_in_bar == 0 then
  beat_in_bar = beats_per_bar 
end 
-----------------





--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////

-- Display Functions for GUI

--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////






--slice clear
-----------------
local function dsliceclear()
    local sample = renoise.song().selected_instrument.samples[1]
    local markers = sample.slice_markers
    for i = 1, #markers, 1 do
      sample:delete_slice_marker(markers[i])
    end
end


--slice4
-----------------
local function dslice4()
    dsliceclear()
    local number_of_slices = 4    
    local sample = renoise.song().selected_instrument.samples[1]
    local frames_per_slice = sample.sample_buffer.number_of_frames / number_of_slices
    for i = 0, number_of_slices - 1, 1 do
      sample:insert_slice_marker(1 + math.floor(i * frames_per_slice))
    end
end

--slice8
-----------------
local function dslice8()
    dsliceclear()
    local number_of_slices = 8   
    local sample = renoise.song().selected_instrument.samples[1]
    local frames_per_slice = sample.sample_buffer.number_of_frames / number_of_slices
    for i = 0, number_of_slices - 1, 1 do
      sample:insert_slice_marker(1 + math.floor(i * frames_per_slice))
    end
end

--slice16
-----------------
local function dslice16()
    dsliceclear()
    local number_of_slices = 16   
    local sample = renoise.song().selected_instrument.samples[1]
    local frames_per_slice = sample.sample_buffer.number_of_frames / number_of_slices
    for i = 0, number_of_slices - 1, 1 do
      sample:insert_slice_marker(1 + math.floor(i * frames_per_slice))
    end
end

--slice32
-----------------
local function dslice32()
    dsliceclear()
    local number_of_slices = 32   
    local sample = renoise.song().selected_instrument.samples[1]
    local frames_per_slice = sample.sample_buffer.number_of_frames / number_of_slices
    for i = 0, number_of_slices - 1, 1 do
      sample:insert_slice_marker(1 + math.floor(i * frames_per_slice))
    end
end



--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////

-- Button Functions for GUI

--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////





--step
-----------------
local function fstep()
    renoise.app().window.active_middle_frame = 1
    renoise.app().window.active_lower_frame = 2
    renoise.app().window.lower_frame_is_visible = true
    renoise.app().window.upper_frame_is_visible = false
    renoise.app().window.pattern_matrix_is_visible = false    
    renoise.song().transport.follow_player = false
    renoise.song().transport.edit_mode = true
    renoise.song().transport.edit_step = 0
end
-----------------


--edit
-----------------
local function fedit()
    if(renoise.app().window.pattern_advanced_edit_is_visible == false) then
    renoise.app().window.active_middle_frame = 1
    renoise.app().window.pattern_advanced_edit_is_visible = true else
    renoise.app().window.pattern_advanced_edit_is_visible = false
    end
end
-----------------


--mute
-----------------
local function fmute()
    if (renoise.song().selected_track.mute_state == 1) then
    renoise.song().selected_track:mute()
    vb.views.mute_on.value = 2
    else
    renoise.song().selected_track:unmute()
    vb.views.mute_on.value = 1
    end
end
-----------------


--solo
-----------------
local function fsolo()
    renoise.song().selected_track:solo()
end 
-----------------


--trackback
-----------------
local function ftrackback()
    if (renoise.song().selected_track_index == 1 ) then return 
    else      
    renoise.song().selected_track_index = renoise.song().selected_track_index - 1
    end
end
-----------------


--trackforward
-----------------
local function ftrackforward()
    if (renoise.song().selected_track_index == #renoise.song().tracks ) then return 
    else
    renoise.song().selected_track_index = renoise.song().selected_track_index + 1
    end
end
-----------------


--loop off
-----------------
local function fundo()   
    renoise.song():undo()
end
-----------------


--loop forward
-----------------
local function fpgmloopfw()
    if (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode == 2) then
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode = 1 else
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode = 2
    end
end
-----------------


--loop back
-----------------
local function fpgmloopbk()
    if (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode == 3) then
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode = 1 else
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode = 3
    end
end
-----------------


--loop pingpong
-----------------
local function fpgmlooppg()
    if (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode == 4) then
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode = 1 else
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode = 4
    end
end
-----------------

--sample instrument beatsync transpose
-----------------
local function fpgmbsynct()
    if (renoise.song().selected_instrument.samples[
    renoise.song().selected_sample_index].beat_sync_enabled == false) then
    renoise.song().selected_instrument.samples[
    renoise.song().selected_sample_index].beat_sync_enabled = true else
    renoise.song().selected_instrument.samples[
    renoise.song().selected_sample_index].beat_sync_enabled = false
    end
end
-----------------


--sample instrument add slice marker
-----------------
local function fpgmslicemarker()
    if (renoise.song().selected_sample.sample_buffer.has_sample_data == true and 
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].is_slice_alias == false) then
    --set a marker    
    renoise.song().selected_instrument.samples[1]:insert_slice_marker(
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].sample_buffer.selection_start)
    else return
    end
end
-----------------


--pgmback
-----------------
local function fpgmback()
    if (renoise.song().selected_instrument_index == 1 ) then 
    return
    else      
    renoise.song().selected_instrument_index = renoise.song().selected_instrument_index - 1
    end
end
-----------------


--pgmforward
-----------------
local function fpgmforward()
    if (renoise.song().selected_instrument_index == #renoise.song().instruments ) then 
    return
    else
    renoise.song().selected_instrument_index = renoise.song().selected_instrument_index + 1
    end
end
-----------------


--sample
-----------------
local function fsample()
    if (renoise.app().window.sample_record_dialog_is_visible == false) then
    renoise.app().window.sample_record_dialog_is_visible = true
    else -- start recording 
    renoise.song().transport:start_stop_sample_recording()
    end
end
-----------------


--trim
-----------------
local function ftrim()
    renoise.app().window.sample_record_dialog_is_visible = false
    renoise.app().window.active_upper_frame = 1
    renoise.app().window.active_middle_frame = 4
    renoise.app().window.active_lower_frame = 3
    renoise.app().window.lower_frame_is_visible = true
    renoise.app().window.upper_frame_is_visible = true
--?    renoise.song().instruments[1].sample_mappings[1].use_envelopes = true
--?   renoise.sample.NEW_NOTE_ACTION_SUSTAIN

end
-----------------


--mixer
-----------------
local function fmixer()
    renoise.app().window.sample_record_dialog_is_visible = false
    renoise.app().window.active_upper_frame = 4
    renoise.app().window.active_middle_frame = 2
    renoise.app().window.active_lower_frame = 1
    renoise.app().window.lower_frame_is_visible = true
    renoise.app().window.upper_frame_is_visible = true
    renoise.app().window.pattern_matrix_is_visible = false
end
-----------------


--save_bpm
-----------------
local function save_bpm(bpm)
    if (bpm >= 32 and bpm <= 999) then renoise.song().transport.bpm = bpm      
    end
end
-----------------


--tap tempo
-----------------
local function tap() 
    local function get_average(tb)
    return (tb[#tb] - tb[1]) / (#tb - 1)
    end
    -------
    local function get_bpm(dt) -- 60 BPM => 1 beat per sec  
    return (60 / dt)
    end
    -------
    local function reset()
    counter = 1
    timetable_filled = false
    while (#timetable > 1) do 
    timetable:remove(1) 
    end
    end
    -------
    local function increase_counter()  
    counter = counter + 1
    if (counter > options.sensitivity.value) then
    timetable_filled = true
    counter = 1
    end  
    end
    -------
    increase_counter()
    -------
    local clock = os.clock()
    timetable:insert(clock) 
    -------  
    if (last_clock > 0 and (clock - last_clock) > 2) then -- reset after 2 sec idle 
    reset()
    end
    -------
    last_clock = clock
    -------
    if (#timetable > options.sensitivity.value) then
    timetable:remove(1)
    end
    -------
    if (timetable_filled) then
    tempo = get_bpm(get_average(timetable))
    local field = "%.2f"
    -------
    if (options.round_bpm.value) then
    tempo = math.floor(tempo + 0.5)
    field = "%d"
    end  
    -------
    if (counter == 1 and options.auto_save_bpm.value) then 
    save_bpm(tempo)
    end  
    end
end  
-----------------


--full level
-----------------
local function flevel()

if (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].volume == 4 ) then 
    for i=1,#renoise.song().selected_instrument.samples do
    renoise.song().selected_instrument.samples[i].volume = 1         
    --set the note to cut when played
    renoise.song().selected_instrument.samples[i].new_note_action = 1
    end
    -------
    else  
    -------
    for i=1,#renoise.song().selected_instrument.samples do
    renoise.song().selected_instrument.samples[i].volume = 4         
    --set the note to continue (overlap) when played
    renoise.song().selected_instrument.samples[i].new_note_action = 3        
    end 
end
end
-----------------


--song
-----------------
local function fsong()
    renoise.app().window.sample_record_dialog_is_visible = false
    renoise.app().window.active_upper_frame = 2
    renoise.app().window.active_middle_frame = 1
    renoise.app().window.active_lower_frame = 4
    renoise.app().window.lower_frame_is_visible = false
    renoise.app().window.upper_frame_is_visible = true
    renoise.app().window.pattern_matrix_is_visible = true
    --additional functions
    renoise.song().transport.follow_player = true
    renoise.song().transport.edit_step = 2
end
-----------------


--program
-----------------
local function fprog()
    renoise.app().window.sample_record_dialog_is_visible = false
    renoise.app().window.active_upper_frame = 1
    renoise.app().window.active_middle_frame = 3
    renoise.app().window.active_lower_frame = 3
    renoise.app().window.lower_frame_is_visible = true
    renoise.app().window.upper_frame_is_visible = true
end
-----------------


--save
-----------------
local function fsave()
    renoise.app():save_song()
end
-----------------


--new
-----------------
local function fnew()
    renoise.app():new_song()
end
-----------------

--instant sample
-----------------
    --close the sample recorder dialog window
    local function fisampleclose()
    renoise.app().window.sample_record_dialog_is_visible = false
    renoise.tool():remove_timer(fisampleclose)
    end
    
local function fisample() 
    --if the instrumnt is new and there is no sample data then create 1 frame
    if (renoise.song().selected_sample.sample_buffer.has_sample_data == false) then
    renoise.song().selected_instrument.samples[1].sample_buffer:create_sample_data(44100, 32, 1, 2)
    end
    
      if (renoise.app().window.sample_record_dialog_is_visible == false and
      sampcount == 0) then
      sampcount = sampcount + 1
      renoise.app().window.sample_record_dialog_is_visible = true
      renoise.song().transport:start_stop_sample_recording()
      print("recording")
    
      else
      renoise.song().transport:start_stop_sample_recording()
      print("recordstop")
      sampcount = 0
      renoise.tool():add_timer(fisampleclose,70) 
 
      end --if
    
end --fisample function
-----------------

--timing
-----------------
local function ftiming()
    if (
    renoise.song().transport.record_quantize_enabled == false) then
    renoise.song().transport.record_quantize_enabled = true
    renoise.song().transport.record_quantize_lines = 2
    vb.views.timingonoff.color = btn_f_on
    else renoise.song().transport.record_quantize_enabled = false
    vb.views.timingonoff.color = btn_f4
    end
end
-----------------


--erase
-----------------
local function ferase()
    renoise.song().selected_pattern_track:clear()
end
-----------------


--step back
-----------------
local function fstepback()
    renoise.song().transport.playback_pos_beats = renoise.song().transport.playback_pos_beats - 0.25
end
-----------------


--step forward
-----------------
local function fstepforward()
    renoise.song().transport.playback_pos_beats = renoise.song().transport.playback_pos_beats + 0.25
end
-----------------


--bar back
-----------------
local function fbarback()
    if (
    --moving back in song do not past bar 0
    renoise.song().transport.playback_pos_beats < 1 ) then
    renoise.song().transport.playback_pos_beats = 0      
    else        
    --move back one bar rounded up  
    renoise.song().transport.playback_pos_beats = math.floor(renoise.song().transport.playback_pos_beats - 1) 
    end
end
-----------------


--bar forward
-----------------
local function fbarforward()
    renoise.song().transport.playback_pos_beats = math.floor(renoise.song().transport.playback_pos_beats + 1)
end
-----------------


--prev sequence
-----------------
local function fprevsq()
    if (renoise.song().selected_sequence_index == 1 ) then 
    return else
    renoise.song().selected_sequence_index = renoise.song().selected_sequence_index -1
    end
end
-----------------



--next sequence
-----------------
local function fnextsq()
    if (renoise.song().selected_sequence_index == #renoise.song().sequencer.pattern_sequence ) then 
    return else
    renoise.song().selected_sequence_index = renoise.song().selected_sequence_index +1
    end
end
-----------------



--record
-----------------
local function frecord()
    renoise.app().window.sample_record_dialog_is_visible = false
    renoise.app().window.active_upper_frame = 2
    renoise.app().window.active_middle_frame = 1
    renoise.app().window.active_lower_frame = 4
    renoise.app().window.lower_frame_is_visible = false
    renoise.app().window.upper_frame_is_visible = false
    renoise.app().window.pattern_matrix_is_visible = true  
    if renoise.song().transport.edit_mode == false then
    renoise.song().transport.edit_mode = true
    renoise.song().transport:start(1)
    vb.views.frecord.color = btn_t_on 
    else
    renoise.song().transport.edit_mode = false
    vb.views.frecord.color = btn_t1
    vb.views.foverdub.color = btn_t1
    end
end
-----------------


--over dub
-----------------
local function foverdub()
    renoise.app().window.sample_record_dialog_is_visible = false
    renoise.app().window.active_upper_frame = 2
    renoise.app().window.active_middle_frame = 1
    renoise.app().window.active_lower_frame = 4
    renoise.app().window.lower_frame_is_visible = false
    renoise.app().window.upper_frame_is_visible = false
    renoise.app().window.pattern_matrix_is_visible = true      
    if (renoise.song().transport.edit_mode == false) then
    renoise.song().transport.edit_mode = true 
    vb.views.foverdub.color = btn_t_on 
    else
    renoise.song().transport.edit_mode = false
    vb.views.foverdub.color = btn_t1
    vb.views.frecord.color = btn_t1 
    end
end
-----------------


--stop
-----------------
local function fstop()
    renoise.song().transport:stop()
    renoise.song().transport.edit_mode = false
    vb.views.frecord.color = btn_t1
    vb.views.foverdub.color = btn_t1
end
-----------------


--play
-----------------
local function fplay()
    renoise.song().transport:start(2)
end
-----------------


--playstart
-----------------
local function fplaystart()
    renoise.song().transport:start(1)
end
-----------------


--transpose samp
-----------------
local function ftransample()
 renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].transpose = vb.views.smptran.value
end  
-----------------


--transpose inst
-----------------
local function ftraninstrument()
    for i=1,#renoise.song().selected_instrument.samples do
    renoise.song().selected_instrument.samples[i].transpose = vb.views.insttran.value
    end
end
-----------------



--sample select start
-----------------
local function fselectstart()
    if (renoise.song().selected_sample.sample_buffer.has_sample_data == true) then
    
    renoise.app().window.active_middle_frame = 4
    
    vb.views.smpstart.min = 1

    --set the new end selection when start moves forwards
    vb.views.smpend.min = math.floor(renoise.song().selected_instrument.
    samples[renoise.song().selected_sample_index].sample_buffer.selection_start + 1)
    
    --dont go past the length of the sample
    vb.views.smpstart.max = renoise.song().selected_instrument.
    samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
    
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].sample_buffer.selection_start =
    vb.views.smpstart.value
    else return
    end
end
-----------------


--sample select end
-----------------
local function fselectend()
    if (renoise.song().selected_sample.sample_buffer.has_sample_data == true) then
    
    renoise.app().window.active_middle_frame = 4
 
    --dont go past the start select range
    vb.views.smpend.min = renoise.song().selected_instrument.
    samples[renoise.song().selected_sample_index].sample_buffer.selection_start + 1
    
    --dont go past the length of the sample
    vb.views.smpend.max = renoise.song().selected_instrument.
    samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
          
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].sample_buffer.selection_end = 
    vb.views.smpend.value
    else return
    end
end
-----------------


--sample select start loop
-----------------
local function fselectstartloop()
    if (renoise.song().selected_sample.sample_buffer.has_sample_data == true) then
    
    vb.views.smpstartloop.min = 1 
    
    --dont allow the end marker to go past the start
    vb.views.smpendloop.min = renoise.song().selected_instrument.
    samples[renoise.song().selected_sample_index].loop_start     
    
    --dont go past the length of the sample
    vb.views.smpstartloop.max = renoise.song().selected_instrument.
    samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
    
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_start =
    vb.views.smpstartloop.value
    else return
    end
end
-----------------


--sample select end loop
-----------------
local function fselectendloop()
    if (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index]
    .sample_buffer.has_sample_data == true) then
    
    --dont go past the start loop marker
    vb.views.smpendloop.min = vb.views.smpstartloop.value + 1
    
    --dont go past the length of the sample
    vb.views.smpendloop.max = renoise.song().selected_instrument.
    samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
          
    renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_end = 
    vb.views.smpendloop.value
    else return
    end
end
-----------------

--volume samp
-----------------
local function fsmprvol()
 renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].volume =
 vb.views.smprvol.value * 4
end  
-----------------


--volume inst
-----------------
local function finstrvol()
    for i=1,#renoise.song().selected_instrument.samples do
    renoise.song().selected_instrument.samples[i].volume =
    vb.views.instrvol.value * 4
    end
end
-----------------

--hide all
-----------------
local function hideall()
  -- toggle visibility of the view on each click
  if (vb.views.gui_display.visible == true and vb.views.gui_control01.visible == false ) then
  -- renoise.app():show_message(("unfold the display."))
  return else
  vb.views.gui_display.visible = not vb.views.gui_display.visible
  vb.views.gui_control01.visible = not vb.views.gui_control01.visible
  vb.views.gui_control02.visible = not vb.views.gui_control02.visible
  end
end  
-----------------


--hide half
-----------------
local function hidehalf()
  -- toggle visibility of the view on each click
  if (vb.views.gui_display.visible == false) then 
  -- renoise.app():show_message(("unfold the tool."))
  return else
  vb.views.gui_control01.visible = not vb.views.gui_control01.visible
  vb.views.gui_control02.visible = not vb.views.gui_control02.visible
  end
end  
-----------------


--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////


--dialog_content
-----------------
local dialog_content = 
  vb:column {
  margin = 8,
  spacing = default_control_spacing,
  -- spread screen display across entire tool
  uniform = true,
-----------------


-------------------------      

vb:horizontal_aligner { --08
       mode = "right",
       
-------------------------


      -----------------       
      vb:bitmap {
      midi_mapping = "MPE:Display:Hide & Show Display",
      mode = "transparent",
      bitmap = "Bitmaps/hd.bmp",
      notifier = function ()
      hidehalf()
      end
      },
      -----------------
      
 
      -----------------
      vb:text {
      tooltip = "Special thanks to (conner_bw)  (esaruoho)  (mxb) .\nIf you are using a demo copy please consider purchasing the full version of Renoise.",
      width = text_row_space,
      align = "right",          
      text = "sevenscientist ",
      }, 
      -----------------
      
      
      -----------------       
      vb:bitmap {
      midi_mapping = "MPE:Display:Hide & Show Tool",
      mode = "transparent",
      bitmap = "Bitmaps/mpe.bmp",
      notifier = function ()
      hideall()
      end
      },
      -----------------
      
      
},  --08


--above screen
--------------

      
--screen  
-----------------
vb:column {   --09 
id = "gui_display",
margin = default_dialog_margin,
spacing = default_control_spacing, 
style = "border",



      

--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////

-- Display Functions 

--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////





-----------------
vb:row{ --10
-----------------
    

      -----------------
      vb:text {
      tooltip = "Change the (Pattern) in the current (Sequence). Decimal values are invalid.",
      width = text_row_space,
      align = "right",          
      text = "sq :",
      },
      ----------------- 
       
       
      ----------------- 
      vb:valuebox {
      id = "sq", 
      min = 1,
      max = 99, 
      value = renoise.song().selected_pattern_index,
      notifier = function(sqs)
      renoise.song().selected_pattern_index = sqs
      end,                  
      },
      ----------------- 
      
                           
   ---------------------------------
    vb:space {width = blank_space},
   ---------------------------------


      ----------------- 
      vb:textfield {
      id = "sqname",
      width = text_row_space + text_row_space,
      align = "left",
      value = renoise.song().selected_pattern.name,      
      notifier = function(sqname)
      renoise.song().selected_pattern.name = sqname 
      end,  
      },
      ----------------- 
      
       
      -----------------           
      vb:text {
      tooltip = "Displays the songs position as BAR.BEAT.COUNT.",        
      width = text_row_space,
      align = "right",          
      text = "now :"
      }, 
      ----------------- 
      
      
      -----------------  
      vb:text {
      id = "nowbar",        
      width = text_row_space, 
      text = tostring(bar),
      font = "bold",
      },
      ----------------- 
      
                 
}, --10


-----------------
vb:row { --11
-----------------   
    
      
      -----------------    
      vb:text {
      tooltip = "Change the song BPM. Decimal values are invalid.",
      width = text_row_space,
      align = "right",
      text = "bpm :",
      }, 
      -----------------
      
      
      -----------------
      vb:valuebox {
      id = "beatpm", 
      min = 32,
      max = 999,
      value = renoise.song().transport.bpm,
      notifier = function(bp)
      renoise.song().transport.bpm = bp
      end,
      },
      -----------------
      
           
   ---------------------------------
    vb:space {width = blank_space},
   ---------------------------------
         
      
      -----------------
      vb:text {
      tooltip = "Enable/Disable (Quantize) by selecting on/off.\nThe values change the songs time resolution.\nHigher values for more detail (speeds up playback)",
      width = text_row_space,
      align = "right",
      text = "timing :"
      }, 
      -----------------
      
      
      ----------------- 
      vb:popup {
      width = text_row_space,
      id = "timing",         
      items = {"-","1/8", "1/16", "1/32", "1/64"},
      notifier = function(timing_change)            
      if (vb.views.timing.items[timing_change] == "1/8") 
      then renoise.song().transport.lpb = 8
      renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines = 32
      vb.views.bars.value = 1
      vb.views.bars.max = 16
      elseif (vb.views.timing.items[timing_change] == "1/16")
      then renoise.song().transport.lpb = 16 
      renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines = 64
      vb.views.bars.value = 1
      vb.views.bars.max = 8
      elseif (vb.views.timing.items[timing_change] == "1/32")
      then renoise.song().transport.lpb = 32 
      renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines = 128
      vb.views.bars.value = 1
      vb.views.bars.max = 4
      elseif (vb.views.timing.items[timing_change] == "1/64")
      then renoise.song().transport.lpb = 64
      renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines = 256 
      vb.views.bars.value = 1 
      vb.views.bars.max = 2        
      elseif (vb.views.timing.items[timing_change] == "-")
      then 
      renoise.song().transport.lpb = original_timing 
      end
      end
      }, 
      -----------------
      
         
   ---------------------------------
    vb:space {width = blank_space},
   ---------------------------------

          
-- display time signature diabled until code is developed
          
--        vb:text {
--          width = text_row_space,
--          align = "right",
--          text = "tsig :"
--          },       
--        vb:popup {
--          width = text_row_space,
--          id = "tsig",          
--          items = {"1/4", "2/4", "3/4", "4/4", "1/8", "2/8", "3/8", "4/8"},
--          },
   
                     
}, -- 11


-----------------
vb:row {  --12 
-----------------


      -----------------
      vb:text {
      tooltip = "Enable/Disable the metronome",
      width = text_row_space,
      align = "right",
      text = "count :",  
      }, 
      -----------------
      
      
      -----------------     
      vb:popup {
      width = text_row_space,
      id = "countm",         
      items = {"no", "yes"},
      notifier = function(count_on_change)      
      if (vb.views.countm.items[count_on_change] == "no") then
      renoise.song().transport.metronome_enabled = false 
      else renoise.song().transport.metronome_enabled = true
      end         
      end   
      },      
      -----------------
      
      
   ---------------------------------
    vb:space {width = blank_space},
   ---------------------------------


      -----------------
      vb:text {
      tooltip = "Repeat the current (Pattern).",
      width = text_row_space,
      align = "right",
      text = "loop :",        
      }, 
      -----------------
      
      
      ----------------- 
      vb:popup {
      width = text_row_space,
      id = "loop",          
      items = {"off", "on"},
      notifier = function(loop_on_change)      
      if (vb.views.loop.items[loop_on_change] == "off") then
      renoise.song().transport.loop_pattern = false 
      else renoise.song().transport.loop_pattern = true
      end        
      end                 
      },    
      -----------------
      
        
      -----------------
      vb:text {
      tooltip = "Change the quantity of (Bars) in a (Pattern).\nDecreasing will not delete notes.\nTime Signature is 4/4.",
      width = text_row_space,
      align = "right",
      text = "bars :"
      }, 
      -----------------
      
      
      ----------------- 
      vb:valuebox {
      id = "bars",
      min = 1,
      max = 16,
      value = 1, 
      width = text_row_space,
      notifier = function(bars_change)
      if (renoise.song().transport.lpb == 8 ) and
      renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines < 511
      then renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines = 32 * vb.views.bars.value
      elseif (renoise.song().transport.lpb == 16) and
      renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines < 511
      then renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines = 64 * vb.views.bars.value
      elseif (renoise.song().transport.lpb == 32) and
      renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines < 511
      then renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines = 128 * vb.views.bars.value
      elseif (renoise.song().transport.lpb == 64) and
      renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines < 511
      then renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines = 256 * vb.views.bars.value
      end
      end         
      },
      -----------------
      
                            
}, --12

        
-----------------
vb:row {  --13
-----------------    


      -----------------
      vb:text {
      tooltip = "The currently selected (Track) in the song.",
      width = text_row_space,
      align = "right",
      text = "track :",
      }, 
      -----------------
      
      
      -----------------  
      vb:valuebox {
      id = "track",
      min = 1,
      max = #renoise.song().tracks,    
      value = renoise.song().selected_track_index,          
      notifier = function(tr)
      renoise.song().selected_track_index  = tr
      --change the instrument (pgm) to match the track
      renoise.song():capture_nearest_instrument_from_pattern()
      end,  
      },   
      -----------------
      
      
     
   ---------------------------------
    vb:space {width = blank_space},
   ---------------------------------
      
      
      -----------------  
      vb:textfield {
      id = "trackname",
      width = text_row_space + text_row_space,
      align = "left",
      value = renoise.song().tracks[renoise.song().selected_track_index].name,
      notifier = function(tname)
      renoise.song().tracks[renoise.song().selected_track_index].name = tname 
      end,  
      }, 
      -----------------
      
      
      -----------------            
      vb:text {
      tooltip = "(Mute) the currently selected (Track).\nWhen displayed as -yes-\nthe track will actually be turned (Off) .",
      width = text_row_space,
      align = "right",
      text = "mute :",        
      }, 
      ----------------- 
      
      
      -----------------
      vb:popup {
      width = text_row_space,
      id = "mute_on",          
      items = {"no", "yes"},          
      notifier = function(mute_on_change)
      if (vb.views.mute_on.items[mute_on_change] == "yes") then
      renoise.song().tracks[renoise.song().selected_track_index]:mute() 
      else renoise.song().tracks[renoise.song().selected_track_index]:unmute()
      end
      end      
      },  
      -----------------
      
                    
},  --13

         
-----------------
vb:row {  --14
-----------------     
      
      
      -----------------       
      vb:text {
      tooltip = "The currently selected (Instrument).\nOr the recorded (Instrument) in the current (Track).",
      width = text_row_space,
      align = "right",
      text = "pgm :",          
      }, 
      -----------------
      
      
      -----------------            
      vb:valuebox {
      id = "pgm",
      min = 1,
      max = #renoise.song().instruments,                    
      value = renoise.song().selected_instrument_index,
      notifier = function(inst)
      renoise.song().selected_instrument_index = inst
      end,
      },   
      -----------------


   ---------------------------------
    vb:space {width = blank_space},
   ---------------------------------
      
      
      -----------------    
      vb:textfield {
      id = "pgmname",
      width = text_row_space + text_row_space,
      align = "left",
      value = renoise.song().selected_instrument.name, 
      notifier = function(pname)
      renoise.song().selected_instrument.name = pname  
      end,                     
      }, 
      -----------------
    
    
      -----------------
      vb:text {
      tooltip = "Slice the selected sample into an even number of slices.\nWorks best with samples that are whole beats in 4/4 signature",
      width = text_row_space,
      align = "right",
      text = "slices :",          
      },
      -----------------
      
      
      -----------------
      vb:popup {
      width = text_row_space,
      id = "slice",         
      items = {"none","4", "8", "16", "32"},
      midi_mapping = "MPE:Display:Slice",
      notifier = function(slice_change)
      if (renoise.song().selected_instrument.samples[1].sample_buffer.has_sample_data) then
          
      if(
      vb.views.slice.items[slice_change] == "none") then
      dsliceclear() elseif     
      vb.views.slice.items[slice_change] == "4" then
      dslice4() elseif      
      vb.views.slice.items[slice_change] == "8" then
      dslice8() elseif
      vb.views.slice.items[slice_change] == "16" then
      dslice16() elseif
      vb.views.slice.items[slice_change] == "32" then
      dslice32()      
      end
      end
      
      end
      },        
      -----------------
 
                           
}, --14 
}, --09



   

--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////

--   Function Buttons  

--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////






-------------------------

vb:column {
  id = "gui_control01",
  margin = default_dialog_margin,

    
vb:horizontal_aligner {
  mode = "center",
  
-------------------------

      
      -----------------
      vb:button {
      tooltip = "Disable (Follow Player Position) and (Enable Record Mode).",
      text = "Step",
      width = btn_function_width,
      color = btn_f1,
      midi_mapping = "MPE:Function:Step Editing",
      pressed = function()
      fstep()
      end 
      },
      -----------------
      
      
      -----------------
      vb:button {
      tooltip = "Enable the (Advanced Edit Functions) for the pattern window.\nSelect/Cut/Copy/Paste.",
      text = "Edit",
      width = btn_function_width,
      color = btn_f1,
      midi_mapping = "MPE:Function:Edit Functions",
      pressed = function()
      fedit()
      end
      },
      -----------------
      
      
      -----------------
      vb:button {
      tooltip = "(Mute) the currently selected (Track).\nThe track will actually be turned (Off) .",
      text = "Mute",
      width = btn_function_width,
      color = btn_f1,
      midi_mapping = "MPE:Function:Mute Track",
      pressed = function()
      fmute() 
      end
      },
      -----------------
      
      
      -----------------
      vb:button {
      tooltip = "(Solo) the currently selected (Track).",
      text = "Solo",
      width = btn_function_width,
      color = btn_f1,
      midi_mapping = "MPE:Function:Solo Track",
      pressed = function()
      fsolo()
      end      
      },
      -----------------


      -----------------
      vb:button {
      tooltip = "Move to the previous (Track) in the song.",
      text = "TR -",
      width = btn_function_width,
      color = btn_f1,
      midi_mapping = "MPE:Function:Select the Previous Track",
      pressed = function()
      ftrackback()
      end
      },     
      -----------------
       

      -----------------
      vb:button {
      tooltip = "Move to the next (Track) in the song.",
      text = "TR +",
      width = btn_function_width,
      color = btn_f1,
      midi_mapping = "MPE:Function:Select Next Track",
      pressed = function()
      ftrackforward()
      end
      },           
      -----------------
       
},      

------------------------------
vb:horizontal_aligner {
  mode = "center",
-------------------------------
      
      
      -----------------
      vb:button {
      tooltip = "Undo the last action",
      text = "Undo",
      color = btn_f2,
      width = btn_function_width,
      midi_mapping = "MPE:Function:Undo",
      pressed = function()
      fundo()
      end 
      },
      -----------------
      
      
      -----------------
      vb:button {
      id = "lpf",
      tooltip = "Sample loop mode forward.",
      text = "loop.F",
      color = btn_f2,
      width = btn_function_width,
      midi_mapping = "MPE:Function:Loop Sample Forward",
      pressed = function()
      fpgmloopfw()
      end 
      },
      -----------------
      
      
      -----------------
      vb:button {
      id = "lpb",
      tooltip = "Sample loop mode backwards.",
      text = "loop.B",
      color = btn_f2,
      width = btn_function_width,
      midi_mapping = "MPE:Function:Loop Sample Back",
      pressed = function()
      fpgmloopbk()
      end 
      }, 
      -----------------


      -----------------
      vb:button {
      id = "lpp",
      tooltip = "Sample loop mode pingpong.",     
      text = "loop.P",
      color = btn_f2,
      width = btn_function_width,
      midi_mapping = "MPE:Function:Loop Sample PingPong",
      pressed = function()
      fpgmlooppg()
      end 
      },
      -----------------


      -----------------
      vb:button {
      id = "pgmsynct",
      tooltip = "Transpose/pitch the current sample to the song BPM.\nTap tempo to the original beat to first.",
      text = "Sync",
      color = btn_f2,
      width = btn_function_width,
      midi_mapping = "MPE:Function:Beatsync Transpose",
      pressed = function()
      fpgmbsynct()
      end 
      },
      -----------------


      -----------------
      vb:button {
      id = "slicemarker",
      tooltip = "Add a slice marker at the current selected start point.\nUse the select start rotary.",
      text = "Slice.M",
      color = btn_f2,
      width = btn_function_width,
      midi_mapping = "MPE:Function:Slice Marker",
      pressed = function()
      fpgmslicemarker()
      end 
      },
      -----------------  
      
        
},   
},

------------------------- 

vb:column {
  id = "gui_control02",
  margin = default_dialog_margin,
                    
vb:horizontal_aligner {
  mode = "center",               

-------------------------    
    

      ----------------- 
      vb:button {
      tooltip = "Record a new sample.",
      text = "SAMPLE",
      color = btn_f3,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Sample",
      pressed = function()
      fsample()
      end
      },
      -----------------


      ----------------- 
      vb:button {
      tooltip = "Display the (Sample Editor Window).",
      text = "TRIM",
      color = btn_f3,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Trim",
      pressed = function()
      ftrim()
      end
      },
      -----------------


      -----------------    
      vb:button {
      tooltip = "Display the (Mixer Window).",
      text = "MIXER",
      color = btn_f3,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Mixer",
      pressed = function()
      fmixer()    
      end
      },
      -----------------


      -----------------            
      vb:button {
      tooltip = "Set the songs BPM.\nTap button in rhythm at least (3) times.",
      text = "TAP.TEMPO",
      color = btn_f1,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Tap Tempo",
      pressed = function()
      tap()
      end 
      },
      -----------------


      -----------------
      vb:button {
      id = "flevel",
      tooltip = "Set (Volume) to maximum for all (Samples).\nIn the selected (Instrument).",
      text = "F.LEVEL",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Full Level",
      pressed = function()
      flevel()
      end
      },
      -----------------

      
},
-------------------------

vb:horizontal_aligner {
  mode = "center",       

-------------------------


      -----------------
      vb:button {
      tooltip = "Display the (Pattern Editor Window).",
      text = "SONG",
      color = btn_f3,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Song",
      pressed = function()
      fsong()
      end
      },
      -----------------


      ----------------- 
      vb:button {
      tooltip = "Display the (Sample Keyzones Window).",
      text = "PROG",
      color = btn_f3,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Program",
      pressed = function()
      fprog()    
      end
      },
      -----------------


      -----------------          
      vb:button {
      tooltip = "Save the current Song.",
      text = "SAVE",
      color = btn_f3,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Save Song",
      pressed = function()
      fsave()
      end
      },
      -----------------


      -----------------    
      vb:button {
      tooltip = "Create a new song.\nwill ask to save or discard current song",
      text = "NEW",
      color = btn_orange,
      width = btn_common_width,
      height = btn_common_height,
      pressed = function()
      fnew()
      end
      },    
      -----------------


      -----------------
      vb:button {
      tooltip = "Instant record a new sample\npress again to stop sampling",
      text = "REC.SAMP",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Instant Sample",
      pressed = function()
      fisample()
      end
      },
      -----------------


},
-------------------------

vb:horizontal_aligner {
      mode = "center",

-------------------------


      -----------------  
      vb:button {
      tooltip = "Switch ON or OFF timing (quantize-2 lines).",
      id = "timingonoff",
      text = "TIMING.Q",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Timing ON",
      pressed = function()
      ftiming()
      end
      },
      -----------------


      -----------------
      vb:button {
      tooltip = "Move the playback position to the previous\n(Pattern) in the song (Sequence) .",
      text = "PREV.SQ",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Previous Sequence",
      pressed = function ()
      fprevsq()
      end
      },
      -----------------


      -----------------
      vb:button {
      tooltip = "Move the playback position to the next\n(Pattern) in the song (Sequence) .",
      text = "NEXT.SQ",
      color = btn_f4,          
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Next Sequence",
      pressed = function ()
      fnextsq()
      end
      },
      -----------------


      -----------------
      vb:button {
      tooltip = "Select the previous (Instrument)",
      text = "PG -",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Select the Previous Instrument",
      pressed = function()
      fpgmback()
      end
      },      
      -----------------


      -----------------
      vb:button {
      tooltip = "Select the next (Instrument)",
      text = "PG +",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Select the Next Instrument",
      pressed = function()
      fpgmforward()
      end
      }, 
      -----------------

        
},

-------------------------

vb:horizontal_aligner {
      mode = "center",
      
-------------------------
 

      -----------------
      vb:button {
      tooltip = "Move the playback position back (quarter beat).",
      text = "< STEP",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Move < 1 step",
      pressed = function ()
      fstepback()
      end
      },
      -----------------


      ----------------- 
      vb:button {
      tooltip = "Move the playback position forward (quarter beat).",
      text = "STEP >",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Move > 1 step",
      pressed = function () 
      fstepforward()
      end
      },
      -----------------


      -----------------   
      vb:button {
      tooltip = "Move the playback position back (1 bar).",
      text = "<< BAR",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Move < 1 bar",
      pressed = function ()
      fbarback()
      end
      },
      -----------------


      ----------------- 
      vb:button {
      tooltip = "Move the playback position forward (1 bar).",
      text = "BAR >>",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Move > 1 bar",
      pressed = function ()
      fbarforward()
      end
      },
      -----------------


      -----------------
      vb:button {
      tooltip = "Clear the current (Pattern) for the selected\n(Track).Can be done while recording.",
      text = "ERASE",
      color = btn_f4,
      width = btn_common_width,
      height = btn_common_height,
      midi_mapping = "MPE:Function:Erase",
      pressed = function()
      ferase()
      end
      },
      -----------------

                         
},


-------------------------

vb:horizontal_aligner {
      mode = "center", 

-------------------------


      -----------------
      vb:button {
      id = "frecord",
      tooltip = "Begin (Record+Playback) from the start of the current (Pattern).",
      text = "Record",
      width = btn_trns_width,
      height = btn_trns_height,
      color = btn_t1,
      midi_mapping = "MPE:Transport:Record",
      pressed = function()
      frecord()
      end
      },
      -----------------


      -----------------            
      vb:button {
      id = "foverdub",
      tooltip = "Enable (Song Recording).",
      text = "OverDUB",
      width = btn_trns_width,
      height = btn_trns_height,
      color = btn_t1,
      midi_mapping = "MPE:Transport:OverDUB",
      pressed = function()
      foverdub()
      end
      },
      -----------------


      -----------------   
      vb:button {
      tooltip = "Stop the song playback and disable the (Song Recording).",
      text = "Stop",
      color = btn_t2,
      width = btn_trns_width,
      height = btn_trns_height,
      midi_mapping = "MPE:Transport:Stop",
      pressed = function()
      fstop()
      end
      },
      -----------------


      -----------------    
      vb:button {
      id = "fplay",
      tooltip = "Begin (Playback) from the current song position.",
      text = "Play",
      color = btn_t2,
      width = btn_trns_width,
      height = btn_trns_height,
      midi_mapping = "MPE:Transport:Play",
      pressed = function()
      fplay()
      end
      },    
      -----------------


      -----------------      
      vb:button {
      id = "fplaystart",
      tooltip = "Begin (Playback) from the start of the current (Pattern).",
      text = "PlaySTART",
      color = btn_t2,
      width = btn_trns_width,
      height = btn_trns_height,
      midi_mapping = "MPE:Transport:PlaySTART",
      pressed = function()
      fplaystart()
      end
      },
      -----------------

                
},


-------------------------

vb:horizontal_aligner { --49
      mode = "center",
      spacing = 4,
      margin = 10, 

-------------------------



      -----------------
      vb:text {
      width = 89,
      align = "center",          
      text = "pitch",
      }, 
      -----------------
      
  
      -----------------
      vb:text {
      width = 89,
      align = "center",          
      text = "select",
      }, 
      ----------------- 


      -----------------
      vb:text {
      width = 89,
      align = "center",          
      text = "loop",
      }, 
      -----------------


      -----------------
      vb:text {
      width = 89,
      align = "center",          
      text = "volume",
      }, 
      ----------------- 
      
}, --49

-------------------------

vb:horizontal_aligner { --50
      mode = "center", 

-------------------------


      -----------------      
      vb:rotary {
      tooltip = "SINGLE sample transpose.\nmidi map-mode = Relative bin offset",
      id = "smptran",
      min = -120, 
      max = 120,
      midi_mapping = "MPE:Sample:Transpose",
      notifier = function()
      ftransample()     
      end
      },      
      -----------------


      -----------------      
      vb:rotary {
      tooltip = "INSTRUMENT sample transpose.\nmidi map-mode = Relative bin offset",
      id = "insttran",
      min = -12, 
      max = 12,
      midi_mapping = "MPE:Sample:Transpose Inst",
      notifier = function()
      ftraninstrument()
      end
      }, 
      -----------------


      -----------------      
      vb:space {width = 20},
      -----------------


      -----------------                    
      vb:rotary {
      tooltip = "SELECT-start sample.",
      id = "smpstart",
      min = 1,
      midi_mapping = "MPE:Sample:Select Start", 
      notifier = function()
      fselectstart()
      end
      },
      -----------------


      -----------------
      vb:rotary {
      tooltip = "SELECT-end sample.",
      id = "smpend",
      min = 1,
      midi_mapping = "MPE:Sample:Select End",
      notifier = function()
      fselectend()
      end
      },
      -----------------


      -----------------
      vb:space {width = 20},
      -----------------


      -----------------                    
      vb:rotary {
      tooltip = "LOOP-start marker.",
      midi_mapping = "MPE:Sample:Loop Start",
      id = "smpstartloop",
      min = 1,
      notifier = function()
      fselectstartloop()
      end
      },
      -----------------


      -----------------
      vb:rotary {
      tooltip = "LOOP-end marker.",
      midi_mapping = "MPE:Sample:Select Loop End",
      id = "smpendloop",
      min = 1,
      notifier = function()
      fselectendloop()
      end
      },
      -----------------


      -----------------       
      vb:space {width = 20},
      -----------------


      -----------------            
      vb:rotary {
      id = "smprvol",
      tooltip = "SINGLE sample volume.",
      midi_mapping = "MPE:Sample:Volume",
      notifier = function()
      fsmprvol()
      end
      },
      -----------------


      -----------------
      vb:rotary {
      id = "instrvol",
      tooltip = "INSTRUMENT sample volume.",
      midi_mapping = "MPE:Sample:Volume Inst",
      notifier = function()
      finstrvol()
      end
      },
      -----------------

  
}, --50


             
},                   
}



----------------------------------------------------------------------
-- key Handler
----------------------------------------------------------------------

local function my_keyhandler_func(dialog, key)
  if not (key.modifiers == "" and key.name == "_") then
  return key
  else
  dialog:close()end
end


--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////

-- Initiate GUI Dialog

--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////


my_dialog = renoise.app():show_custom_dialog("mpe", dialog_content,my_keyhandler_func)


-----------------------------------------------------------
-- function that runs with timer to update the GUI 
-----------------------------------------------------------

local function view_updater(my_dialog,beats_per_bar) 

-----------------------------------------------------------

  -- get user GUI values
  beats_per_bar = 4
  starting_pattern = nil
  
  -- get renoise values
  local lpb = renoise.song().transport.lpb
  local current_pos = renoise.song().transport.playback_pos_beats
  local current_sequence_pos = renoise.song().transport.playback_pos.sequence
  
  --adjust current pos when first pattern = upbeats
  if starting_pattern == true then
    --pattern 1 length   renoise.song().sequencer.pattern_sequence[1]
    local sequencer_index_1 = renoise.song().sequencer.pattern_sequence[1]
    local pattern_1_length = renoise.song().patterns[sequencer_index_1].number_of_lines
    --pattern 1 beats
    local pattern_1_beats = pattern_1_length/ lpb
    current_pos = current_pos - pattern_1_beats
  end
  
  --set values and calculate bars + beats
  local total_rounded_beats = math.floor(current_pos + 1)
  local bar = (total_rounded_beats / beats_per_bar) 
    bar = math.ceil(bar)
  local beat_in_bar = total_rounded_beats % beats_per_bar
  if beat_in_bar == 0 then
    beat_in_bar = beats_per_bar 
  end



--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

-- update GUI  

--%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



--update bar
local lpb = renoise.song().transport.lpb
local nol = renoise.song().patterns[renoise.song().selected_pattern_index].number_of_lines
if (lpb == 8 and nol == 32 ) then
   vb.views.bars.value = 1 elseif
   (lpb == 8 and nol == 32 * 2 ) then
   vb.views.bars.value = 2 elseif
   (lpb == 8 and nol == 32 * 3 ) then
   vb.views.bars.value = 3 elseif
   (lpb == 8 and nol == 32 * 4 ) then
   vb.views.bars.value = 4 elseif
   (lpb == 8 and nol == 32 * 5 ) then  
   vb.views.bars.value = 5 elseif
   (lpb == 8 and nol == 32 * 6 ) then
   vb.views.bars.value = 6 elseif
   (lpb == 8 and nol == 32 * 7 ) then
   vb.views.bars.value = 7 elseif
   (lpb == 8 and nol == 32 * 8 ) then
   vb.views.bars.value = 8 elseif
   (lpb == 8 and nol == 32 * 9 ) then
   vb.views.bars.value = 9 elseif
   (lpb == 8 and nol == 32 * 10 ) then
   vb.views.bars.value = 10 elseif
   (lpb == 8 and nol == 32 * 11 ) then
   vb.views.bars.value = 11 elseif
   (lpb == 8 and nol == 32 * 12 ) then  
   vb.views.bars.value = 12 elseif
   (lpb == 8 and nol == 32 * 13 ) then
   vb.views.bars.value = 13 elseif
   (lpb == 8 and nol == 32 * 14 ) then
   vb.views.bars.value = 14 elseif
   (lpb == 8 and nol == 32 * 15 ) then
   vb.views.bars.value = 15 elseif
   (lpb == 8 and nol == 32 * 16 ) then
   vb.views.bars.value = 16 elseif 

   (lpb == 16 and nol == 64 ) then
   vb.views.bars.value = 1 elseif
   (lpb == 16 and nol == 64 * 2 ) then
   vb.views.bars.value = 2 elseif
   (lpb == 16 and nol == 64 * 3 ) then
   vb.views.bars.value = 3 elseif
   (lpb == 16 and nol == 64 * 4 ) then
   vb.views.bars.value = 4 elseif
   (lpb == 16 and nol == 64 * 5 ) then  
   vb.views.bars.value = 5 elseif
   (lpb == 16 and nol == 64 * 6 ) then
   vb.views.bars.value = 6 elseif
   (lpb == 16 and nol == 64 * 7 ) then
   vb.views.bars.value = 7 elseif
   (lpb == 16 and nol == 64 * 8 ) then
   vb.views.bars.value = 8 elseif
   
   (lpb == 32 and nol == 128 ) then
   vb.views.bars.value = 1 elseif
   (lpb == 32 and nol == 128 * 2 ) then
   vb.views.bars.value = 2 elseif
   (lpb == 32 and nol == 128 * 3 ) then
   vb.views.bars.value = 3 elseif
   (lpb == 32 and nol == 128 * 4 ) then
   vb.views.bars.value = 4 elseif

   (lpb == 64 and nol == 256 ) then
   vb.views.bars.value = 1 elseif
   (lpb == 64 and nol == 256 * 2 ) then
   vb.views.bars.value = 2
   
end

--update slice
if (renoise.song().selected_instrument.samples[1].sample_buffer.has_sample_data) then
if (#renoise.song().selected_instrument.samples[1].slice_markers == 0 ) then
vb.views.slice.value = 1 elseif 
(#renoise.song().selected_instrument.samples[1].slice_markers == 4 ) then
vb.views.slice.value = 2 elseif 
(#renoise.song().selected_instrument.samples[1].slice_markers == 8 ) then
vb.views.slice.value = 3 elseif 
(#renoise.song().selected_instrument.samples[1].slice_markers == 16 ) then
vb.views.slice.value = 4 elseif 
(#renoise.song().selected_instrument.samples[1].slice_markers == 32 ) then
vb.views.slice.value = 5 
end
end

--update sequence name and number when it changes in song
--vb.views.sq.max = #renoise.song().patterns
vb.views.sq.value = renoise.song().selected_pattern_index
vb.views.sqname.value = renoise.song().selected_pattern.name

--update now
vb.views["nowbar"].text = "0"..tostring(bar)..".0"..tostring(beat_in_bar).."."..tostring(total_rounded_beats)

--update BPM when it changes in song
vb.views.beatpm.value = renoise.song().transport.bpm

--update the count when the (metronome) changes in song
if (renoise.song().transport.metronome_enabled == false) then
vb.views.countm.value = 1 
else vb.views.countm.value = 2 
end

--update loop (repeat pattern) when it changes in song
if (renoise.song().transport.loop_pattern == false) then
vb.views.loop.value = 1 else 
vb.views.loop.value = 2
end  
      
-- update trackname and number when it changes in song
vb.views.track.max = #renoise.song().tracks
vb.views.track.value = renoise.song().selected_track_index
vb.views.trackname.value = renoise.song().tracks[renoise.song().selected_track_index].name

              
--update instrument (pgm) when it changes in song including deleted or added
vb.views.pgm.max = #renoise.song().instruments
vb.views.pgm.value = renoise.song().selected_instrument_index          
vb.views.pgmname.value = renoise.song().selected_instrument.name
      
--update the (mute) field when changing track selection
if (renoise.song().tracks[renoise.song().selected_track_index].mute_state == 1) then
vb.views.mute_on.value = 1 else 
vb.views.mute_on.value = 2
end

--update transpose sample
vb.views.smptran.value = renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].transpose

--update volume
vb.views.smprvol.value = renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].volume / 4

--update the sync button for the selected instrument
if (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].beat_sync_enabled == true) then 
vb.views.pgmsynct.color = btn_f_on else
vb.views.pgmsynct.color = btn_f2
end

--update the full level button for the selected instrument
if (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].volume == 4 ) then 
vb.views.flevel.color = btn_f_on else
vb.views.flevel.color = btn_f4
end

--update the instrument loop mode
if (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode == 1 ) then 
vb.views.lpf.color = btn_f2 
vb.views.lpb.color = btn_f2
vb.views.lpp.color = btn_f2
elseif (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode == 2) then
vb.views.lpf.color = btn_f_on
vb.views.lpb.color = btn_f2
vb.views.lpp.color = btn_f2
elseif (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode == 3) then
vb.views.lpf.color = btn_f2
vb.views.lpb.color = btn_f_on
vb.views.lpp.color = btn_f2
elseif (renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_mode == 4) then
vb.views.lpf.color = btn_f2
vb.views.lpb.color = btn_f2
vb.views.lpp.color = btn_f_on
end

--updatesample selection maximum range
if (renoise.song().selected_sample.sample_buffer.has_sample_data == true) then
vb.views.smpend.max = renoise.song().selected_instrument.
samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
--
vb.views.smpstart.max = renoise.song().selected_instrument.
samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
else return
end

--updatesample loop maximum range
if (renoise.song().selected_sample.sample_buffer.has_sample_data == true) then
vb.views.smpendloop.max = renoise.song().selected_instrument.
samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
--
vb.views.smpstartloop.max = renoise.song().selected_instrument.
samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
else return
end

----------------------------------------------------------------------
end --local function view_updater 
----------------------------------------------------------------------

--add timer
if not renoise.tool():has_timer(view_updater) then
  renoise.tool():add_timer(view_updater ,5)
end


----------------------------------------------------------------------
-- close on document(song) and release timer (tested and works)
----------------------------------------------------------------------

local function closer(d)    
  if d and d.visible then
  d:close()end
  if renoise.tool():has_timer(view_updater) then
  renoise.tool():remove_timer(view_updater)
  end  
end
--add notifier on document(song) release 
if not renoise.tool().app_release_document_observable:has_notifier(closer) then 
  renoise.tool().app_release_document_observable:add_notifier(closer, my_dialog)
end

----------------------------------------------------------------------
-- release updater function (tested and works)
----------------------------------------------------------------------

local function release_updater(d)
  if not d.visible then
  if renoise.tool():has_timer(view_updater) then
  renoise.tool():remove_timer(view_updater) 
  end        
  if renoise.tool():has_timer(release_updater) then
  renoise.tool():remove_timer(release_updater)
  print(renoise.tool():has_timer(release_updater)) 
  end
  end
end

--add second timer (slower) to release updater when dialog closes (tested and works)  
if not renoise.tool():has_timer(release_updater) then
  renoise.tool():add_timer(function () release_updater(my_dialog) end ,200) 
end

--focus pattern editor
renoise.app().window.lock_keyboard_focus = false
renoise.app().window.lock_keyboard_focus = true


--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////

-- Custom MIDI Mapping

--////////////////////////////////////////////////////////////////////////////////////////////////
--////////////////////////////////////////////////////////////////////////////////////////////////


if not 
  renoise.tool():has_midi_mapping("MPE:Function:Step Editing")
  then


renoise.tool():add_midi_mapping{
name = "MPE:Display:Hide & Show Display",
invoke = function(message)
  if (message:is_trigger()) then  
  hidehalf()
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Display:Hide & Show Tool",
invoke = function(message)
  if (message:is_trigger()) then  
  hidehall()
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Display:Slice",
invoke = function(message)
  if (message:is_trigger()) then  
  
  if (dispcount == 5) then dispcount = 0 else
  dispcount = dispcount + 1
  print(dispcount)
  
  if (dispcount == 1) then dsliceclear() elseif
  (dispcount == 2) then dslice4() elseif
  (dispcount == 3) then dslice8() elseif
  (dispcount == 4) then dslice16() elseif
  (dispcount == 5) then dslice32() 
  end
  
  end
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Undo",
invoke = function(message)
  if (message:is_trigger()) then  
  fundo()
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Loop Sample Forward",
invoke = function(message)
  if (message:is_trigger()) then  
  fpgmloopfw()
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Loop Sample Back",
invoke = function(message)
  if (message:is_trigger()) then  
  fpgmloobk()
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Loop Sample PingPong",
invoke = function(message)
  if (message:is_trigger()) then  
  fpgmlooppg()
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Beatsync Transpose",
invoke = function(message)
  if (message:is_trigger()) then      
  fpgmbsynct()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Slice Marker",
invoke = function(message)
  if (message:is_trigger()) then      
  fpgmslicemarker()     
  end
  end
}
      
renoise.tool():add_midi_mapping{
name = "MPE:Sample:Transpose",
invoke = function(message)
  if (message.int_value >= 61 or message.int_value <= -61 )then return else
  vb.views.smptran.value = math.floor(message.int_value * 2 )
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Sample:Transpose Inst",
invoke = function(message)
  if (message.int_value >= 61 or message.int_value <= -61 )then return else
  vb.views.insttran.value = math.floor(message.int_value * 0.2)
  end
  end
} 


renoise.tool():add_midi_mapping{
name = "MPE:Sample:Select Start",
invoke = function(message)
if (renoise.song().selected_sample.sample_buffer.has_sample_data == true) then
  
  if (message.int_value >= 128 or message.int_value == 0 )then return else
  renoise.app().window.active_middle_frame = 4
  vb.views.smpstart.value = 1
  --set the views value from midi
  vb.views.smpstart.value =
  math.floor(renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].
  sample_buffer.number_of_frames  
  * message.int_value /  127)
  end -- if
  
end -- if
end --function
}


renoise.tool():add_midi_mapping{
name = "MPE:Sample:Select End",
invoke = function(message)
if (renoise.song().selected_sample.sample_buffer.has_sample_data == true) then
  
  local start = math.floor(127 /
  renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames * 
  renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].sample_buffer.selection_start)    
  
  if (message.int_value <= start )then return else
  renoise.app().window.active_middle_frame = 4 
  --end minimum
  vb.views.smpend.min = renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].
  sample_buffer.selection_start
  --end maximum
  vb.views.smpend.max = renoise.song().selected_instrument.
  samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
  --set the views value from midi
  vb.views.smpend.value = 
  math.floor(renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].
  sample_buffer.number_of_frames  
  * message.int_value / 127)
  end -- if
  
end -- if
end --function
}

renoise.tool():add_midi_mapping{
name = "MPE:Sample:Loop Start",
invoke = function(message)
if (renoise.song().selected_sample.sample_buffer.has_sample_data == true) then

  if (message.int_value >= 128 or message.int_value == 0 )then return else  
  renoise.app().window.active_middle_frame = 4
  --start minimum
  vb.views.smpstartloop.min = 1
  --start maximum
  vb.views.smpstartloop.max = renoise.song().selected_instrument.
  samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
  --set the views value from midi
  vb.views.smpstartloop.value = 
  renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames 
  * math.floor(message.int_value) / 127  
  end -- if
  
end -- if
end --function
}


renoise.tool():add_midi_mapping{
name = "MPE:Sample:Loop End",
invoke = function(message)
if (renoise.song().selected_sample.sample_buffer.has_sample_data == true) then

  local start = math.floor(127 /
  renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames * 
  renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].loop_start)
  
  if (message.int_value <= start )then return else
  renoise.app().window.active_middle_frame = 4
  --end minimum
  vb.views.smpendloop.min = renoise.song().selected_instrument.samples[renoise.song().
  selected_sample_index].loop_start
  --end maximum
  vb.views.smpendloop.max = renoise.song().selected_instrument.
  samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames
  --set the views value from midi
  vb.views.smpendloop.value =
  renoise.song().selected_instrument.samples[renoise.song().selected_sample_index].sample_buffer.number_of_frames 
  * math.floor(message.int_value) / 127  
  end -- if
  
end -- if
end --function
}

renoise.tool():add_midi_mapping{
name = "MPE:Sample:Volume",
invoke = function(message)
  if (message.int_value >= 61 )then return else
  vb.views.smprvol.value = message.int_value / 60
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Sample:Volume Inst",
invoke = function(message)
  if (message.int_value >= 61 )then return else
  vb.views.instrvol.value = message.int_value / 60
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Loop Sample",
invoke = function(message)
  if (message:is_trigger()) then      
  fpgmloop()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Select the Previous Instrument",
invoke = function(message)
  if (message:is_trigger()) then      
  fpgmback()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Select the Next Instrument",
invoke = function(message)
  if (message:is_trigger()) then      
  fpgmforward()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Step Editing",
invoke = function(message)
  if (message:is_trigger()) then      
  fstep()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Edit Functions",
invoke = function(message)
  if (message:is_trigger()) then      
  fedit()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Mute Track",
invoke = function(message)
  if (message:is_trigger()) then      
  fmute()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Solo Track",
invoke = function(message)
  if (message:is_trigger()) then      
  fsolo()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Select the Previous Track",
invoke = function(message)
  if (message:is_trigger()) then      
  ftrackback()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Select Next Track",  
invoke = function(message)
  if (message:is_trigger()) then      
  ftrackforward()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Sample",
invoke = function(message)
  if (message:is_trigger()) then      
  fsample()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Trim",
invoke = function(message)
  if (message:is_trigger()) then      
  ftrim()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Mixer",
invoke = function(message)
  if (message:is_trigger()) then      
  fmixer()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Tap Tempo",
invoke = function(message)
  if (message:is_trigger()) then      
  tap()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Full Level",
invoke = function(message)
  if (message:is_trigger()) then      
  flevel()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Song",
invoke = function(message)
  if (message:is_trigger()) then      
  fsong()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Program",
invoke = function(message)
  if (message:is_trigger()) then      
  fprog()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Save Song",
invoke = function(message)
  if (message:is_trigger()) then      
  fsave()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Instant Sample",
invoke = function(message)
  if (message:is_trigger()) then      
  fisample()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Erase",
invoke = function(message)
  if (message:is_trigger()) then      
  ferase()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Move < 1 step",
invoke = function(message)
  if (message:is_trigger()) then      
  fstepback()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Move > 1 step",
invoke = function(message)
  if (message:is_trigger()) then      
  fstepforward()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Move < 1 bar",
invoke = function(message)
  if (message:is_trigger()) then      
  fbarback()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Move > 1 bar",
invoke = function(message)
  if (message:is_trigger()) then      
  fbarforward()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Previous Sequence",
invoke = function(message)
  if (message:is_trigger()) then      
  fprevsq()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Function:Next Sequence",
invoke = function(message)
  if (message:is_trigger()) then      
  fnextsq()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Transport:Record",
invoke = function(message)
  if (message:is_trigger()) then      
  frecord()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Transport:OverDUB",
invoke = function(message)
  if (message:is_trigger()) then      
  foverdub()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Transport:Stop",
invoke = function(message)
  if (message:is_trigger()) then      
  fstop()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Transport:Play",
invoke = function(message)
  if (message:is_trigger()) then      
  fplay()     
  end
  end
}

renoise.tool():add_midi_mapping{
name = "MPE:Transport:PlaySTART",
invoke = function(message)
  if (message:is_trigger()) then      
  fplaystart()     
  end
  end
}

else return
end

----------
end --main
